#include <stdio.h>
#include <iostream.h>
#include <somd.xh>
#include "DSOMBindings.xh"

/*
#include <somoa.xh>
#include <implrep.xh>
*/

//#define SET
#define GET
#define SIMPLE /* Enable it in order to have a local instance */


Environment   ev;



void TestSNMP()
{
  Liaison_DSOMSNMPObj *snmpObj;
  int vers;

#ifdef SIMPLE
  snmpObj = new Liaison_DSOMSNMPObj;
#elif LOCAL_CREATION
  SOMClass*     cls;
  SOMObject*    obj;

  cls=SOMClassMgrObject->somFindClass(somIdFromString("::Liaison::DSOMSNMPObj"), 0, 0);
    if(!cls) {
      cerr << "Class ::Liaison::DSOMSNMPObj could not be retrieved !" << endl;
      SOMD_Uninit(&ev);
      return -1;
    }
    obj=cls->somNew();
    if(!obj) {
      cerr << "Instance of class ::Liaison::DSOMSNMPObj could not be created ! " << endl;
      SOMD_Uninit(&ev);
      return -1;
    }

  snmpObj = (Liaison_DSOMSNMPObj*)obj;
#else
  SOMObject*    obj;
  SOMDServer*  server;

  Liaison_DSOMInformationNewClass(0, 0);
  Liaison_DSOMCMIPObjNewClass(0, 0);
  Liaison_DSOMSNMPObjNewClass(0, 0);
  
 server=SOMD_ObjectMgr->somdFindServerByName(&ev, "kae");
  if(server)
    obj=(SOMDObject*)server->somdCreateObj(&ev, "::Liaison::DSOMSNMPObj", "");
  else
    {
      printf("Server not found !\n");
      return;
    }
  
  snmpObj = (Liaison_DSOMSNMPObj*)obj;

#endif

  snmpObj->UseProxy(&ev, "kae.zurich.ibm.com", 4002);

  vers = snmpObj->GetProxyBindingsVersion(&ev);
  
  if(somExceptionId(&ev) == NO_EXCEPTION)   
    printf("Bindings version: %d\n", vers);
  else
    {
      printf("EXCEPTION: %s\n", somExceptionId(&ev));
      somExceptionFree(&ev); /* Free exception */
      delete snmpObj;
      return;
    }

  snmpObj->SetSnmpAgentAddress(&ev, "aug", 160);
  snmpObj->SetAttribute(&ev, "sysDescr.0", NULL);

  snmpObj->SNMPGetAttribute(&ev); /* Send the SNMP Get */
  
  printf("\n----------------------\n\n");

  char *out = snmpObj->GetAttribute(&ev, "sysDescr.0");
  if(somExceptionId(&ev) == NO_EXCEPTION)
    printf("Value: %s\n", out);
  else
    {
      printf("EXCEPTION: %s\n", somExceptionId(&ev));
      somExceptionFree(&ev); /* Free exception */
    }

  printf("\n----------------------\n\n");

  snmpObj->CreateTrapListener(&ev, 4096);
  printf("TrapListener created successfully\n\n");

  printf("# Traps available: %d\n\n", snmpObj->TrapsAvailable(&ev));
  
  printf("Waiting for 3 traps...\n");
  
  for(int i=0; i<3; i++)
    {
      Liaison_DSOMInformation *info = snmpObj->WaitForTraps(&ev, -1);
      

      if(somExceptionId(&ev) == NO_EXCEPTION)
	{
	  _IDL_SEQUENCE_string attrs =  info->GetAttributes(&ev);
	  _IDL_SEQUENCE_string keys  =  info->GetAttributeKeys(&ev);
	  
	  for(int i=0; i<attrs._length; i++)
	    {
	      printf("%s - %s\n", keys._buffer[i], attrs._buffer[i]);
	      SOMFree(attrs._buffer[i]), SOMFree(keys._buffer[i]);
	    }
	  
	  SOMFree(attrs._buffer), SOMFree(keys._buffer);	     
	}
      else
	{
	  printf("EXCEPTION: %s\n", somExceptionId(&ev));
	  somExceptionFree(&ev); /* Free exception */
	  delete info;
	}

    }
  
  printf("Deleting TrapListener....\n");    
  snmpObj->DeleteTrapListener(&ev);
  printf("\nTrapListener deleted successfully\n");
  
  delete snmpObj;
}


void TestCMIP()
{
  int i, vers;
  Liaison_DSOMCMIPObj *cmipObj;

  cmipObj = new Liaison_DSOMCMIPObj;
  cmipObj->SetAgentAET(&ev, "2001");
  cmipObj->UseProxy(&ev, "kae.zurich.ibm.com", 4002);

  vers = cmipObj->GetProxyBindingsVersion(&ev);
  
  if(somExceptionId(&ev) == NO_EXCEPTION)   
    printf("Bindings version: %d\n", vers);
  else
    {
      printf("EXCEPTION: %s\n", somExceptionId(&ev));
      somExceptionFree(&ev); /* Free exception */
      delete cmipObj;
      return;
    }

#ifdef GET
  cmipObj->SetObjectInstance(&ev, "netId=\"TelcoNet\"@systemId=(name \"misaOS_ZRL\")");

#ifdef SCOPE  
  _IDL_SEQUENCE_Liaison_DSOMInformation  contInst =  cmipObj->CMIPGetContainedInstances(&ev);

  if(somExceptionId(&ev) == NO_EXCEPTION)
    {
      for(i=0; i<contInst._length; i++)
	{
	  _IDL_SEQUENCE_string attrs =  contInst._buffer[i]->GetAttributes(&ev);
	  _IDL_SEQUENCE_string keys  =  contInst._buffer[i]->GetAttributeKeys(&ev);
	  
	  for(int i=0; i<attrs._length; i++)
	    {
	      printf("%s - %s\n", keys._buffer[i], attrs._buffer[i]);
	      SOMFree(attrs._buffer[i]), SOMFree(keys._buffer[i]);
	    }

	  SOMFree(attrs._buffer), SOMFree(keys._buffer);
	  
	  printf("\n");
	}

      printf("\n----------------------\n\n");
    }
  else
    {
      printf("EXCEPTION: %s\n", somExceptionId(&ev));
      somExceptionFree(&ev); /* Free exception */
    }
#endif

  
  cmipObj->CMIPGetAttributes(&ev);

  
  if(somExceptionId(&ev) == NO_EXCEPTION)
    {
      _IDL_SEQUENCE_string attrs =  cmipObj->GetAttributes(&ev);
      _IDL_SEQUENCE_string keys  =  cmipObj->GetAttributeKeys(&ev);
      
      for(i=0; i<attrs._length; i++)
	{
	  printf("%s - %s\n", keys._buffer[i], attrs._buffer[i]);
	  SOMFree(attrs._buffer[i]), SOMFree(keys._buffer[i]);
	}

      SOMFree(attrs._buffer), SOMFree(keys._buffer);
    }
  else
    {
      printf("EXCEPTION: %s\n", somExceptionId(&ev));
      somExceptionFree(&ev); /* Free exception */
    }
#endif

#ifdef SET

  cmipObj->RemoveAllAttributes(&ev);
  cmip->SetAttribute(&ev, "allomorphs", "(ObjectClass gBCMServiceProvider, ObjectClass top, ObjectClass system)");
  cmipObj->CMIPSetAttributes(&ev);
  
  if(somExceptionId(&ev) == NO_EXCEPTION)
    {
      _IDL_SEQUENCE_string attrs =  cmipObj->GetAttributes(&ev);
      _IDL_SEQUENCE_string keys  =  cmipObj->GetAttributeKeys(&ev);
      
      for(i=0; i<attrs._length; i++)
	{
	  printf("%s - %s\n", keys._buffer[i], attrs._buffer[i]);
	  SOMFree(attrs._buffer[i]), SOMFree(keys._buffer[i]);
	}

      SOMFree(attrs._buffer), SOMFree(keys._buffer);
    }
  else
    {
      printf("EXCEPTION: %s\n", somExceptionId(&ev));
      somExceptionFree(&ev); /* Free exception */
    }
#endif


  delete cmipObj;
}


int main(int argc, char* argv[]) {
  int i;

  /* Initialization */
  SOM_InitEnvironment(&ev); SOMD_Init(&ev);    
  
  printf("Ready.\n\n");
  
  /* ************************************** */

  TestCMIP();

  printf("\n\n");

  TestSNMP();

  /* ************************************** */

  /* Termination */
  SOMD_Uninit(&ev); SOM_UninitEnvironment(&ev);

  return 0;
}

