#include "ProxyBindings.h"

void TestBindings() {
  SNMPObj *snmp;
  int i;
  struct    timeval tv1, tv2;
  struct    timezone tz;
  double secs, usecs;

  
  try {
    snmp = new SNMPObj("aug.zurich.ibm.com");
    snmp->UseProxy("kae.zurich.ibm.com", 1998);

    /*
    Information **in = snmp->SNMPWalk();
    for(i=0; in[i] != NULL; i++)
      in[i]->print();
      */


    snmp->SetAttribute("ifInOctets.2", NULL);
    /*
    for(i=0; i<30; i++)
      {
	snmp->SNMPGetAttribute(); 
	snmp->print();
      }
      */

    
    //snmp->SNMPSetAttribute(); 

    for(i=0; i<30; i++)
      {       
	gettimeofday(&tv1, &tz);  
	snmp->SNMPGetAttribute();    
	//snmp->SNMPGetNextAttribute();    
	gettimeofday(&tv2, &tz);  
	secs=tv2.tv_sec-tv1.tv_sec;
	usecs=(double)tv2.tv_usec-tv1.tv_usec;
	usecs/=1000000;
	secs+=usecs;
	printf("%.2f secs \n", secs);
	snmp->print();
      }

    delete snmp;
  } catch(char* str) {
    printf("Exception: %s\n", str);
  }
}


void TestTraps() {
  SNMPObj *snmp;
  int i;
  
  try {
    snmp = new SNMPObj("aug.zurich.ibm.com");
    snmp->UseProxy("kae.zurich.ibm.com", 1998);

    snmp->CreateTrapListener(4096);
    printf("TrapListener created successfully\n\n");

    printf("# Traps available: %d\n\n", snmp->TrapsAvailable());

    printf("Waiting for 3 traps...\n");
	
    for(int i=0; i<3; i++)
      {
     	Information *info = snmp->WaitForTraps(-1);
	
	if(info != NULL)
	  {
	    info->print();
	    delete info;
	  }
      }

    printf("Deleting TrapListener....\n");    
    snmp->DeleteTrapListener();
    printf("\nTrapListener deleted successfully\n");

    delete snmp;
    return;
  } catch(char* str) {
    printf("Exception: %s\n", str);
  }
}


int main(int argc, char* argv[]) {
  TestTraps();
  return(0);
}
