#include "ProxyBindings.h"

//#define ACTION
#define EVR
//#define GET
//#define SET

int main(int argc, char* argv[]) {
  CMIPObj *cmip;
  SNMPObj *snmp;
  int i;
  struct    timeval tv1, tv2;
  struct    timezone tz;
  double secs, usecs;

  try {

    /* ************** CMIP ************** */
#define CMIP


#ifdef CMIP
    cmip = new CMIPObj("2001");
    cmip->UseProxy("kae.zurich.ibm.com", 1998);
    
    printf("Bindings version: %ld\n", cmip->GetProxyBindingsVersion());


#ifdef EVR
     cmip->CreateEFD("genericNetworkId=TelcoNet@systemId=(name atmNLOS_UK)", NULL);
    /*
      cmip->CreateEFD("genericNetworkId=TelcoNet@systemId=(name atmNLOS_UK)", 
		    "(item (equality (objectClass, atmNetworkAccessPoint)))");
		    */
     // cmip->CreateEFD(NULL, NULL);
    printf("EFD created successfully\n\n");

    printf("# Notifications available: %d\n\n", cmip->NotificationsAvailable());
	
    for(int i=cmip->NotificationsAvailable(); i>0; i--)
      {
     	Information *info = cmip->WaitForNotifications(-1);
	
	if(info != NULL)
	  {
	    info->print();
	    delete info;
	  }
      }

    printf("Waiting....\n");
   Information *info = cmip->WaitForNotifications(-1);
	
    if(info != NULL)
      {
	info->print();
	delete info;
      }

    printf("Deleting EFD....\n");    
    cmip->DeleteEFD();
    printf("\nEFD deleted successfully\n");

    delete cmip;
    return(0);
#endif


    // cmip->SetObjectInstance("genericNetworkId=TelcoNet@customerID=(name IBM)");
    cmip->SetObjectInstance("netId=\"TelcoNet\"@systemId=(name \"misaOS_ZRL\")");

//#define SCOPED
//#define DELETE

#ifdef SCOPED
    cmip->SetAttribute("scope", "(baseToNthLevel 2)"); // Whole
    gettimeofday(&tv1, &tz);  
    Information **v = cmip->CMIPGetContainedInstances();
    gettimeofday(&tv2, &tz);  
    for(i=0; v[i] != NULL; i++)
      {
	v[i]->print();
	delete v[i];
      }

    delete v;

    printf("%d response(s)\n", i);
#else
    gettimeofday(&tv1, &tz);  

#ifdef SET
    //cmip->SetAttribute("contactList", "()");
    //cmip->SetObjectInstance("netId=TelcoNet;customerID=(name IBM);networkId=(pString Europe)");    
    //cmip->SetAttribute("networkTitle", "(oid 1.2.3)");    
    cmip->SetAttribute("allomorphs", "(ObjectClass gBCMServiceProvider, ObjectClass top, ObjectClass system)");    
    cmip->CMIPSetAttributes();  
#endif

#ifdef ACTION


    /*
    cmip->SetObjectClass("atmSubNetwork");
    cmip->SetAttribute("actionType", "0.3.1.1.1.2.9.1");

    cmip->SetAttribute("actionInfoArg", 
		       "(aAccessPoint (distinguishedName 'netId=\"TelcoNet\"@systemId=(name \"atmNLOS_UK\")"
		       "@subNetworkId=(pString \"misaAtmSubnet_UK\")@atmAccessPointId=(pString \"atmNAP6\")'), "
		       "zAccessPoint (distinguishedName 'netId=\"TelcoNet\"@systemId=(name \"atmNLOS_UK\")"
		       "@subNetworkId=(pString \"misaAtmSubnet_UK\")@atmAccessPointId=(pString \"atmNAP4\")'), "
		       "directionality bidirectional,schedule (startTime (continual NULL), stopTime (continual NULL), "
		       "(durationScheduling (aToZ (NULL null), zToA (NULL null)))))");
		       */

    cmip->SetObjectClass("qsdhBasicSubNetwork");
    cmip->SetObjectInstance("netId=\"TelcoNet\"@systemId=(name \"sdhNLOS_UK\")@subNetworkId=(pString qsdhSubnet_UK)");
    cmip->SetAttribute("actionType", "0.4.0.653.0.9.17");

    cmip->SetAttribute("actionInfoArg", 
		       "(sncDirectionality (ptoPBidirectional (aEnd (sncTp (distinguishedName 'netId=\"TelcoNet\""
		       "@systemId=(name \"sdhNLOS_UK\")@subNetworkId=(pString \"qsdhSubnet_UK\")@qsdhNetworkAccessPointId"
		       "=(string \"MisaNAP1\")@qsdhNetworkAccessPointId=(string \"MisaNAP11\")')), zEnd (sncTp (distingui"
		       "shedName 'netId=\"TelcoNet\"@systemId=(name \"sdhNLOS_UK\")@subNetworkId=(pString \"qsdhSubnet_UK"
		       "\")@qsdhNetworkAccessPointId=(string \"MisaNAP1\")@qsdhNetworkAccessPointId=(string \"MisaNAP12\")"
		       "')))), statusCondition (lifecycleState inService, assignmentState reserved, availabilityStatus (0)),"
		       "signalid (simple 0.0.13.3100.0.0.0.12))");

    cmip->CMIPPerformAction(1);

    cmip->print();
    
    delete cmip;
    return(0);
#endif

#ifdef GET
    cmip->CMIPGetAttributes();  
#endif

#ifdef DELETE
    // cmip->CMIPDeleteObject(); 
    
    cmip->SetObjectClass("1.2.124.360501.3.46");
    cmip->SetAttribute("sync", "bestEffort");
    cmip->SetAttribute("scope", "(basicScope 2)"); // Whole
    cmip->CMIPDeleteContainedInstances();
#endif

    gettimeofday(&tv2, &tz);  
    //printf("allomorphs: %s\n", cmip->GetAttribute("allomorphs"));
    cmip->print();
#endif

    secs=tv2.tv_sec-tv1.tv_sec;
    usecs=(double)tv2.tv_usec-tv1.tv_usec;
    usecs/=1000000;
    secs+=usecs;
    printf("%.2f secs \n", secs);

    delete cmip;
#endif

  } catch(char* str) {
    printf("Exception: %s\n", str);
  }
  
  return(0);
}

