#include <stdio.h>

#include "ProxyCBindings.h"

void safe_strcpy(char* dest, char* src) {

  if(src == NULL)
    dest[0] = '\0';
  else
    strcpy(dest, src);
}

void test1() 
{
  char* retVal = GetSNMPAttribute("saz", 1998, "valais", 161, "public", "sysName.0");

  if(retVal != NULL)
    printf("%s\n", retVal);
  else
    printf("Error: %s\n", GetLiaisonLastError());
}


void test2() 
{
  char * oid;
  char *theObj = CreateSNMPObject("aug", 161);

  if(theObj == NULL)
    {
      printf("Error: Unable to create instance\n");
      return;
    }

  UseProxy(theObj, "kae", 1998);
  SetAttribute(theObj, "sysName.0", NULL);
  
  if(SNMPGetAttribute(theObj) == 0)
    printf("%s\n", GetAttribute(theObj, "sysName.0"));
  else
    printf("Error: %s\n", GetLiaisonLastError());

  oid = ConvertSNMPOID(theObj, "sysName.0");

  if(oid != NULL)
      printf("OID: %s\n", oid);
  else
    printf("Error: %s\n", GetLiaisonLastError());

  DeleteObj(theObj);
}
 

void test3() 
{
  char *nextOID, *oid;
  char* retVal = GetNextSNMPAttribute("aug", 1998, "lde", 161, "public", "sysName.0", &nextOID);

  if(retVal != NULL)
    printf("[%s, %s]\n", nextOID, retVal);
  else
    printf("Error: %s\n", GetLiaisonLastError());


  oid = QuickConvertSNMPOID("aug", 1998, "snmpInPkts.0");

  if(oid != NULL)
      printf("OID: %s\n", oid);
  else
    printf("Error: %s\n", GetLiaisonLastError());
}
 

void CMIP_Test() 
{
  char cmip[16], cmip1[16], *host="kae", *mibname="2001";
  char instances[16], instances1[16], info[16], *objInst;
  int  parentLen;

  safe_strcpy(cmip, CreateCMIPObject(mibname));
  UseProxy(cmip, host, 1998);

  safe_strcpy(cmip1, CreateCMIPObject(mibname));
  UseProxy(cmip1, host, 1998);

  safe_strcpy(instances, CMIPGetContainedInstances(cmip));

  if(instances[0] == '\0')
    {
      printf("Error: %s\n", GetLiaisonLastError());
      return;
    }

  safe_strcpy(info, GetNextListElement(instances));

  while((info != NULL) && (info[0] != '\0'))
    {

      objInst = GetObjectInstance(info);

      if((objInst != NULL) && (objInst[0] != '\0'))
	{
	  printf("%s\n", objInst);

	  SetObjectInstance(cmip1, objInst);
	  safe_strcpy(instances1, CMIPGetContainedInstances(cmip1));

	  if(instances1[0] != '\0')
	    {
	      int index=1;

	      safe_strcpy(info, GetNextListElement(instances1));

	      if(objInst == NULL)
		parentLen = 0;
	      else
		parentLen = strlen(objInst);

	      while((parentLen > 0) && (info[0] != '\0'))
		{
		  objInst = GetObjectInstance(info);

		  if(objInst == NULL)
		    break;
		  printf("[%2d] %s\n", index++, objInst);
	
		  safe_strcpy(info, GetNextListElement(instances1));
		}
	    }
	}

      safe_strcpy(info, GetNextListElement(instances)); 
    }

  DeleteObj(cmip);
  DeleteObj(cmip1);
}


int main(int argc, char* argv[]) 
{
  CMIP_Test();

  ShutDownLiaisonBindings(); /* Optional but recomm}ed */
  return(0);
}
