import java.awt.*;
import java.lang.*;
import java.util.*;
import java.text.*;

class VertGraph extends Panel 
{
   Font        font = null;
   int width, height;
   int	       yPlot= 25;
   int     	   inset = 25, horLine = 125;
   int 	       last_y=0;
   int         pointSize = 12;
   boolean     done=false;
   Graphics	   offGraphics=null;
   Image	   gfxBuff=null;
   Color       colors[] = { Color.blue, Color.red, Color.green, 
                            Color.orange, Color.cyan, Color.magenta };
   
   public final Color BACKGROUND = Color.lightGray /* new Color(225, 225, 225) */;
   public final int   VERTICALLY = 0;
   public final int   HORIZONTALLY = 1;
   public final int   LEFT = 0;
   public final int   BELOW = 1;
   boolean scatterMode=false;

   public VertGraph()
   {
      font = new Font("Helvetica", Font.PLAIN, 9);
      setBackground(Color.white);
   }


 public void addPoint(String theString) 
   {
	offGraphics.setColor(Color.blue);

	offGraphics.drawString(DateFormat.getDateInstance().format(new Date()), 5, yPlot);
	offGraphics.drawString(theString, horLine+5, yPlot);
	yPlot += pointSize;
	
	if(yPlot >= height)
	{		
		offGraphics.copyArea(1, pointSize, width-2, 
						height-pointSize, 0, 1-pointSize);
		
		offGraphics.setColor(BACKGROUND);
		offGraphics.fillRect(1, height-pointSize, width-1, pointSize);
	    offGraphics.setColor(Color.black);
	    offGraphics.drawLine(horLine, 1, horLine, height-1);
		yPlot -= pointSize;
	}

	//getGraphics().drawImage(gfxBuff, 0, 0, null);
	repaint();
  }

 public void paint(Graphics g) 
   {
   	  if(gfxBuff == null)
	  {	  
	    Dimension d=getSize();
	    width = d.width - 2 * inset;
	    height = d.height - 2 * inset;

	    gfxBuff = createImage(d.width, d.height);
	    offGraphics = gfxBuff.getGraphics();
	    
	    offGraphics.setFont(font);
	    // Put an outer border on the entire graph area.
	    offGraphics.setColor(Color.gray);
	    offGraphics.draw3DRect(1, 1, getBounds().width - 2, 
				   getBounds().height - 2, true);
	    
	    // Fill the paint area, leaving a border.
	    offGraphics.setColor(BACKGROUND);
	    offGraphics.translate(inset, inset);
	    offGraphics.fillRect(0, 0, width, height);
	    
	    // Draw Division Line
	    offGraphics.setColor(Color.black);
	    offGraphics.drawLine(horLine, 1, horLine, height-1);
	    
	    // Draw X and Y axes
	    offGraphics.drawLine(0, 0, 0, height);
	    offGraphics.drawLine(0, height, width, height);
	    
	    // Draw shading
	    offGraphics.setColor(Color.gray);
	    offGraphics.drawLine(0, 0, width, 0);
	    offGraphics.drawLine(width, 0, width, height);
	    
	    offGraphics.setColor(Color.blue);
	    offGraphics.drawString("Luca Deri, February 1996", width-100, height+15);
	  }
	  
	  g.drawImage(gfxBuff, 0, 0, null);
	}
   
 }  
