/***********************************************************************

     IBM Confidential

     OCO Source Materials

     (C) Copyright IBM Corporation 1995-96

     The source code for this program is not published or
     otherwise divested of its trade secrets, irrespective of
     what has been deposited with the U.S. Copyright Office.

***********************************************************************/

#define RECORDING_PORT           1996 /* HTTP YP Server          */
#define RPC_PORT                 1997 /* RPC-like comms          */
#define HTTP_LISTEN_PORT         1998 /* HTTP listen port        */
#define SHTTP_LISTEN_PORT        1998 /* Secure HTTP listen port */

#define BASE_SSL_DISPLACEMENT    1024 /* Used for SSL connections */

#define DONT_LOAD_ON_DEMAND            0
#define LOAD_ON_DEMAND                 1

#define NOTOK                         -1
#define OK                             0

#define TOOL_VERSION                  /*0.*/73
/* Component Identifiers */
#define NO_MORE_TYPES                 -1
#define CORE_APPLICATION               0
/* Range reserved for future use      */
#define PROXY_YP_SERVER               40
/* Range reserved for future use      */
#define PROXY_TOP_MESSAGE            255

#define USE_CCI                        1
#define DONT_USE_CCI                   0


#define CW_QUEUE                 "MIBCTL"


#define ATTR_TABLE   0
#define CLASS_TABLE  1

#define LONG_STRING   20	/* size of a string containing a long */
#define AVG_STR_LEN  128        /* size for strings of average lenght */
#define MAX_STR_LEN  512        /* maximum size of certain strings */
#define MAX_PATH_STR 1024	/* maximum string size for path
				 * variables */

#ifdef OS2
#define TIMEOUT             60
#define SHORT_TIMEOUT       30
#define FIELD_LEN           32
#define SHORT_FIELD_LEN     16
#else /* AIX */
#define TIMEOUT             30
#define SHORT_TIMEOUT       15
#define FIELD_LEN           48
#define SHORT_FIELD_LEN     24
#endif

#define SLEEP_TIME_TOOLS_UPDATE  5 /* seconds */

#define LONG_TIMEOUT            240 /* 4 minutes */

#define LAST     1
#define NOT_LAST 0

/* Kind of response returned */
#ifndef ERROR
#define ERROR      '0'
#endif
#ifndef NOERROR
#define NOERROR    '1'
#endif

/* Values for type of response */
#define OI_LOOKUP  '1'

#define LOOKUP_BUFSIZE  512
#define CCI_ARRAY_LEN 64

#ifndef OK
#define OK     0
#define NOTOK -1
#endif

/* For SNMP tables */
#define SNMP_DEFAULT_PORT  161

#define MAX_NUM_ROWS       512
#define MAX_NUM_COLUMNS     48

#define MAX_NUM_HOSTS     1024
#define MAX_NET_NUM         32

#define SNMP_OID_LIST_SIZE 4096

#define MAX_RPC_SOCKETS     8
#define MAX_USER_SOCKETS   16

/* SNMP Types */
#define TYPE_OTHER	    0
#define TYPE_OBJID	    1
#define TYPE_OCTETSTR	    2
#define TYPE_INTEGER	    3
#define TYPE_NETADDR	    4
#define	TYPE_IPADDR	    5
#define TYPE_COUNTER	    6
#define TYPE_GAUGE	    7
#define TYPE_TIMETICKS	    8
#define TYPE_OPAQUE	    9
#define TYPE_NULL	    10
#define TYPE_COUNTER64      11
#define TYPE_BITSTRING      12
#define TYPE_NSAPADDRESS    13
#define TYPE_UINTEGER	    14
#define TYPE_TABLE	    15
#define TYPE_MIB	    16

#define STR_LEN            256
#define STR_LEN_LARGE      512

/***** SUPPORTED EVENTS ******/
/* Events 0-255 are reserved for the system */
#define MIN_SYSTEM_EVENT            0
#define TIME_EVENT                 16
#define COMPONENT_SHUT_DOWN        17
#define MAX_SYSTEM_EVENT          255
/* Events 256-1023 can be used by developers */
#define MAX_HANDLED_EVENT        1023

/***** ERROR CODES ******/
#ifndef NO_ERROR
#define NO_ERROR                      0
#endif
#define UNKNOWN_HOST               -128
#define SOCKET_CREATION_FAILED     -129
#define RPC_CALL_FAILED            -130
#define EVENT_QUEUE_FULL           -131
#define EMPTY_EVENT_QUEUE          -132
#define EVENT_OUT_OF_RANGE         -133
#define UNKNOWN_EVENT              -134
#define NOT_OWNER                  -135
#define UNKNOWN_SERVICE            -136
#define UNEXISTING_PEER            -137
#define RPC_TIMEOUT                -138
#define INVALID_STRING             -139

/***** OS/2 Export *****/
#ifdef OS2
#define UNLINK _unlink
#else
#define UNLINK unlink
#endif

/***** FUNCTION PROTOTYPES *****/
void CloseSocket(int sockId); /* ProxyUtils.C */

/***** DATA TYPES *****/

#include "ProxyPersonality.h"
