/***********************************************************************

     IBM Confidential

     OCO Source Materials

     (C) Copyright IBM Corporation 1995-96

     The source code for this program is not published or
     otherwise divested of its trade secrets, irrespective of
     what has been deposited with the U.S. Copyright Office.

***********************************************************************/

#ifndef _PROXY_PERSONALITY_H_
#define _PROXY_PERSONALITY_H_

#if defined(_POWER) /* AIX 4.X */ || defined(__linux__)
#define THREAD_RET_TYPE  void*
#define THREAD_RET_VALUE return(NULL);
#elif OS2
#define THREAD_RET_TYPE  void _Optlink
#define THREAD_RET_VALUE /* Nothing to return */
#else /* AIX 3.X, MacOS... */
#define THREAD_RET_TYPE  void
#define THREAD_RET_VALUE /* Nothing to return */
#endif

#ifndef SEMAPHORES_ONLY

extern char shortVersStr[], applName[], personalityName[], fileDividerChar;
extern void DoSleep(int secs);

/* Function Prototypes */
class Personality {
  
public:
  Personality();
  ~Personality();
  
  int LoadModule(char* dllName, void** dllHandle);
  int UnloadModule(void* dll_handle);
  unsigned long GetDropletModificationDate(char* dllName); /* Used mostly for droplets */
  int GetModuleEntryPoint(void* dll_handle, void** pproc_addr);
  int ReadDir(char* dir, char *elements[]);
  int CreateToolIdx(char* dir);
  void CreateThread(THREAD_RET_TYPE(*FuncPtr)(void *), void* args, long* threadId);
  void KillThread(long threadId);
  void SetThreadAttributes();
  void CancelCurrentThread();
  void CleanUpThread();
};

#endif /* SEMAPHORES_ONLY */

#ifndef STHREAD
class CondVariable {
  void*  mutex;
  void*  condvar;
  int    pred;       // 0 -> unset, 1 -> set
public:
                   CondVariable();
  virtual          ~CondVariable();
  int              Wait();
  int              Signal(); /* Unlocks one waiting thread */
};


class MutexSemaphore {
 public:
  MutexSemaphore();
  ~MutexSemaphore();

  int access();
  int release();
 private:
  void *mutex_sem;
};

#endif

#endif
