/***********************************************************************

     IBM Confidential

     OCO Source Materials

     (C) Copyright IBM Corporation 1995-96

     The source code for this program is not published or
     otherwise divested of its trade secrets, irrespective of
     what has been deposited with the U.S. Copyright Office.

***********************************************************************/

#ifndef _PROXY_TABLE_H_
#define _PROXY_TABLE_H_

#include "ProxyGlobals.h"
#include "ProxyTypes.h"

#define boolean char

typedef struct HashEntry {
  char* key_name;
  void* entry_data;
} HashEntry;

#define FREE_NO_MEMORY                 0
#define FREE_DATA_MEMORY_ONLY          1
#define FREE_KEY_MEMORY_ONLY           2
#define FREE_DATA_AND_KEY_MEMORY       3

class HashTable {
private:
  int totalSlots, slotsInUse;
  HashEntry* slots;
  char** keys;
  void** values;
  int ComputeHashValue(char*);
  boolean freeMemory;

public:
  HashTable(unsigned int numSlots=256, boolean _freeMemory=FREE_NO_MEMORY);
  ~HashTable();
  void  AddEntry(char* key, void* data);
  void* RetrieveEntry(char* key);
  void RemoveEntry(char* key);
  void RemoveAllEntries();
  void** GetEntries();
  char** GetEntryKeys();
  int GetNumEntries() { return(slotsInUse); };
};

/********************************************/


class EventQueue {
private:
  int totalSlots, numEntries;
  EventInfo** slots;
  long nextEventExpireTime; /* -1 == No Event */

public:
  EventQueue(unsigned int numSlots=256);
  ~EventQueue();
  
  int AddEvent(EventInfo*);
  EventInfo* GetEvent();
  int NumEventsAvailable() { return(numEntries); };
  void SortQueue();
  long GetNextEventExpireTime();
};

#endif
