/***********************************************************************

     IBM Confidential

     OCO Source Materials

     (C) Copyright IBM Corporation 1995-96

     The source code for this program is not published or
     otherwise divested of its trade secrets, irrespective of
     what has been deposited with the U.S. Copyright Office.

***********************************************************************/


#define CALLMODE
#ifdef AIX
#define soclose(a) close(a)
#elif WIN32
#include "Win_Includes.h"

#undef  CALLMODE
#define CALLMODE _cdecl
#endif

#ifdef __cplusplus
extern "C" {
#endif

void InitLiaisonBindings();
void ShutDownLiaisonBindings();

char* GetLiaisonLastError();
void  ResetLiaisonLastError();

/******************** Information *************************/

void  UseProxy(char* theObj, char* address, int port);
char* GetAttribute(char* theObj, char* oid);
void  SetAttribute(char* theObj, char* oid, char* value);
void  RemoveAllAttributes(char* theObj);
void  ResetAttributeList(char* theObj);
void  GetNextAttributeListElement(char* theObj, char** oid, char** value);


/****************** Every Class ***********************/

void DeleteObj(char* infoObj);

/****************** (Information**) ***********************/

char* GetNextListElement(char* theObj);  /* NOTE: 1) the returned pointer is Information*
						  2) user responsability to free the returned pointer */

/******************** SNMPObj *************************/

char* GetSNMPAttribute(char* LiaisonHost, int LiaisonPort, 
		       char* SNMPAgentHost, int SNMPport, 
		       char* community, char* attrId); /* Shortcut */

char* GetNextSNMPAttribute(char* LiaisonHost, int LiaisonPort, char* SNMPAgentHost, 
			   int SNMPport, char* community, char* attrId, char** nextOID); 

char* CreateSNMPObject(char* remAgt, int remAgtPort);

void  SetSnmpAgentAddress(char* snmpObj, char* remAgt, int remAgtPort);
int   SNMPGetAttribute(char* snmpObj);
char* SNMPWalk(char* snmpObj);                           /* NOTE: the returned pointer is a list (Information**) */
int   SNMPGetNextAttribute(char* snmpObj);
int   SNMPSetAttribute(char* snmpObj);
char* SNMPGetAttributeInfo(char* snmpObj, char* syntax);
char* ConvertSNMPOID(char* snmpObj, char* syntax);
char* QuickConvertSNMPOID(char* LiaisonHost, int LiaisonPort, char* attrId) ;


/******************** CMIPObj *************************/

char* CreateCMIPObject(char* agentAET);

void  SetAgentAET(char* cmipObj, char* aet);
void  SetObjectClass(char* cmipObj, char* val);
char* GetObjectClass(char* cmipObj);
void  SetObjectInstance(char* cmipObj, char* val);
char* GetObjectInstance(char* cmipObj);  
void  CMIPCreateObject(char* cmipObj);
void  CMIPDeleteObject(char* cmipObj);
char* CMIPDeleteContainedInstances(char* cmipObj); /* NOTE: the returned pointer is a list (Information**) */
int   CMIPGetAttributes(char* cmipObj);
char* CMIPGetContainedInstances(char* cmipObj);    /* NOTE: the returned pointer is a list (Information**) */
int   CMIPSetAttributes(char* cmipObj);
char* CMIPSetContainedInstances(char* cmipObj);    /* NOTE: the returned pointer is a list (Information**) */
int   CMIPPerformAction(char* cmipObj, int confirmed);
char* CMIPPerformActionContainedInstances(char* cmipObj, int confirmed); /* NOTE: the returned pointer 
									          is a list (Information**) */
char* GetActions(char* cmipObj);                   /* NOTE: 1) the returned pointer is Information*
						            2) User responsability to free the returned pointer */
char* ConvertOID(char* cmipObj, char* oid);        
char* GetNameBindings(char* cmipObj);              /* NOTE: 1) the returned pointer is Information*
						            2) User responsability to free the returned pointer */
char* ConvertOID(char* cmipObj, char* oid);        
int   NotificationsAvailable(char* cmipObj);
int   CreateEFD(char* cmipObj, char* systemInstance, char* filter);
void  DeleteEFD(char* cmipObj);
char* WaitForNotifications(char* cmipObj, int timeout);  /* NOTE: 1) the returned pointer is Information*
						                  2) User responsability to free the returned pointer */
char* GetSyntaxInfo(char* cmipObj, char* syntax);  /* NOTE: User responsability to free the returned pointer */
char* ConvertOID(char* cmipObj, char* oid);        /* NOTE: User responsability to free the returned pointer */


/******************************************************/

#ifdef __cplusplus
}; /* extern "C" { */
#endif

