/************************************************************

  Name:         VertUpdater.java

  Description:  Updater class for CMIP Applet Demo

  Coded by:     Luca Deri (lde@zurich.ibm.com)

  Licensed Materials - Property of IBM

  (C) Copyright IBM Corporation 1995-96.  All Rights Reserved.

**************************************************************/

import java.lang.*;
import java.awt.*;
import java.util.*;



public class VertUpdater implements Runnable {
  Thread t;
  CMIPObj cmip;
  VertGraph _vg;
  String _moi, lastElem=null; 
  Choice _refreshRate, _attribute;

  public void SetElement(VertGraph vg, String moi,
			 Choice refreshRate, Choice attribute) {

    _vg=vg; _moi=moi; _refreshRate=refreshRate; _attribute=attribute;

    cmip = new CMIPObj("MIBCTL"); /* OSI Agent AE-Title */

    try {
      cmip.UseProxy("misa.zurich.ibm.com", 1998); /* Host where the Proxy runs */
    } catch(Exception e) {
      System.out.println(e);
      e.printStackTrace();
      return;
    }
	  
    cmip.SetObjectInstance(_moi);
    _vg.repaint();
  }



  public void run( ) {
    int i;

    System.out.println("Welcome to the IBM ZRL CMIP Attribute Monitor Applet");
    //After 1000 reqs. the applet stops: this avoids to load Liasion forever
		
        for(i=0;i<1000;i++) {

	  try {
	    if(lastElem != null)
	      cmip.RemoveAttribute(lastElem);

	    lastElem = _attribute.getSelectedItem();
	    cmip.SetAttribute(lastElem,"");

	    System.out.println("Issuing request "+i+" ...");
	    cmip.CMIPGetAttributes();
	    System.out.println("...received response. ["+(new Date())+"]");

	    _vg.addPoint(lastElem+"="+(String)cmip.GetAttribute(lastElem));
			  
	    Thread.sleep(1000*(Integer.valueOf(_refreshRate.getSelectedItem()).intValue()));
	  } catch(Exception e) {
	    System.out.println(e);
	    e.printStackTrace();
	  }
	}
    System.out.println("Issued "+i+" requests. Thanks for using this applet.");  
  }

} 




