/************************************************************

  Name:         Updater.java

  Description:  Updater class for SNMP Applet Demo

  Coded by:     Luca Deri (lde@zurich.ibm.com)

  Licensed Materials - Property of IBM

  (C) Copyright IBM Corporation 1995-96.  All Rights Reserved.

**************************************************************/

import java.lang.*;
import java.awt.*;
import java.util.*;



public class Updater implements Runnable {
  Thread t;
  StatsGraph ce;
  SNMPObj snmp;
  int numInPckts=0, inPkt;
  int numOutPckts=0, outPkt;
  int sleepTime;



  public void SetElement(StatsGraph c, int sleep) {
    ce=c; sleepTime=sleep;
	  
    snmp = new SNMPObj("misa.zurich.ibm.com", 160); /* SNMP Agent */

    try {
      snmp.UseProxy("misa.zurich.ibm.com", 1998); /* Host where the Proxy runs */
    } catch(Exception e) {
      System.out.println(e);
      return;
    }

    snmp.SetAttribute("ifInOctets.1","");
    snmp.SetAttribute("ifOutOctets.1","");
    ce.setMin(0);
    ce.setMax(25000);
  }


  public void run( ) {
    int a=-1, b=-1, i;
    boolean first=true;
		
    System.out.println("Welcome to the IBM ZRL TCP/IP Traffic Monitor Applet");
    //After 1000 reqs. the applet stops: this avoids to load Liasion forever
      
        for(i=0;i<1000;i++) {

	  try {
	    System.out.println("Issuing request "+i+" ...");
	    snmp.SNMPGetAttribute();
	    //System.out.println(snmp);
	    System.out.println("...received response. ["+(new Date())+"]");

	    inPkt = (Integer.valueOf((String)snmp.GetAttribute("ifInOctets.1"))).intValue();
	    if(numInPckts != 0)
	      a=inPkt-numInPckts;
	    numInPckts = inPkt;
			  	
	    outPkt = (Integer.valueOf((String)snmp.GetAttribute("ifOutOctets.1"))).intValue();
	    if(numOutPckts != 0)
	      b=outPkt-numOutPckts;
	    numOutPckts = outPkt;

	    if(!first)
	      ce.addPoint(a+b);
	    else
	      first=false;		  

	    Thread.sleep(sleepTime);
	  } catch(Exception e) {
	    System.out.println(e);
	  }
	}

    System.out.println("Issued "+i+" requests. Thanks for using this applet");  

  }

} 




